API reference
Every HTTP endpoint of the functions module: authentication, IAM action, parameters, bodies and status codes.
Generated from the module's code when its image was built — do not edit. Paths are relative to https://api.example.com.
Docs
GET /docs/functions/manifest.json
- Authentication: required
- Operation name:
DocsManifest_functions
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid |
GET /docs/functions/{path}
- Authentication: required
- Operation name:
DocsFile_functions
Parameters
| Name | In | Type | Required |
|---|---|---|---|
path |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid |
Function Source
DELETE /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}/source
Deletes stored source after the controller has consumed it.
- Authentication: required
- Operation name:
DeleteFunctionSource
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}/source
Returns the stored source zip for a function.
- Authentication: required
- Operation name:
GetFunctionSource
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid |
POST /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}/source
Uploads function source code. The backend zips it before storing.
- Authentication: required
- IAM action:
functions/write— evaluated at the resource in the path - Operation name:
UploadFunctionSource
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Request body: UploadSourceRequest
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/write at the evaluated scope |
FunctionComputePlans
GET /boundaries/{boundaryId}/resources/functioncomputeplans
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
FunctionNamespaces
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | PagedListResponse<FunctionNamespaceDto> |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/config
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path - Operation name:
GetFunctionNamespacesConfig
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | string |
Yes |
resourceGroupName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
DELETE /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}
- Authentication: required
- IAM action:
functions/delete— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/delete at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
PATCH /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}
- Authentication: required
- IAM action:
functions/write— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Request body: any
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/write at the evaluated scope |
POST /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}
- Authentication: required
- IAM action:
functions/write— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Request body: FunctionNamespaceDto
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/write at the evaluated scope |
PUT /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}
- Authentication: required
- IAM action:
functions/write— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Request body: FunctionNamespaceDto
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/write at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/deployments
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
POST /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/deployments
- Authentication: required
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Request body: DeploymentLogEntryDto
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid |
PUT /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/deployments/{deploymentId}
- Authentication: required
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
deploymentId |
path | uuid |
Yes |
Request body: DeploymentLogEntryDto
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid |
POST /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/deployments/{deploymentId}/logs
- Authentication: required
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
deploymentId |
path | uuid |
Yes |
Request body: UploadBuildLogsRequest
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | PagedListResponse<FunctionDto> |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
DELETE /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}
- Authentication: required
- IAM action:
functions/delete— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/delete at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
POST /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}
- Authentication: required
- IAM action:
functions/write— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Request body: FunctionDto
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/write at the evaluated scope |
PUT /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}
- Authentication: required
- IAM action:
functions/write— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Request body: FunctionDto
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/write at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}/logs
- Authentication: required
- IAM action:
functions/readLogs— evaluated at the resource in the path; a data action
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/readLogs at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}/metrics
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
from |
query | integer |
No |
step |
query | string |
No |
stepSeconds |
query | integer |
No |
to |
query | integer |
No |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}/metrics/web
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
PUT /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/functions/{functionName}/scale
- Authentication: required
- IAM action:
functions/scale— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
functionName |
path | string |
Yes |
Request body: ScaleRequest
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/scale at the evaluated scope |
GET /boundaries/{boundaryId}/resourcegroups/{resourceGroupName}/resources/functionnamespaces/{namespaceName}/logs
- Authentication: required
- IAM action:
functions/readLogs— evaluated at the resource in the path; a data action
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
resourceGroupName |
path | string |
Yes |
namespaceName |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/readLogs at the evaluated scope |
GET /boundaries/{boundaryId}/resources/functionnamespaces
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | PagedListResponse<FunctionNamespaceDto> |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
GET /boundaries/{boundaryId}/resources/functionnamespaces/config
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path - Operation name:
GetAllFunctionNamespacesConfig
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | string |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
POST /boundaries/{boundaryId}/resources/functionnamespaces/url
- Authentication: required
- IAM action:
functions/write— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
Request body: FunctionNamespaceNameRequest
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/write at the evaluated scope |
FunctionRuntimes
GET /boundaries/{boundaryId}/resources/functionruntimes
- Authentication: required
- IAM action:
functions/read— evaluated at the resource in the path
Parameters
| Name | In | Type | Required |
|---|---|---|---|
boundaryId |
path | uuid |
Yes |
Responses
| Status | Meaning | Body |
|---|---|---|
200 |
OK | |
401 |
Not signed in, or the token is invalid | |
403 |
The caller does not hold functions/read at the evaluated scope |
Other endpoints
GET /readyz
- Authentication: none — anonymous callers are accepted
- Operation name:
StackshipReadiness
Responses
| Status | Meaning | Body |
|---|
Schemas
AuthConfigDto
| Property | Type | Nullable |
|---|---|---|
audience |
string |
Yes |
enabled |
boolean |
No |
issuer |
string |
Yes |
DeploymentLogEntryDto
| Property | Type | Nullable |
|---|---|---|
boundaryId |
uuid |
No |
deploymentId |
uuid |
No |
functionName |
string |
Yes |
id |
uuid |
No |
lastMessage |
string |
No |
namespaceName |
string |
No |
phase |
string |
No |
resourceGroupName |
string |
No |
source |
string |
Yes |
timestamp |
date-time |
No |
FunctionDto
| Property | Type | Nullable |
|---|---|---|
auth |
AuthConfigDto |
Yes |
clusterId |
uuid |
No |
clusterName |
string |
No |
computePlan |
string |
No |
createdAt |
date-time |
No |
endpoint |
string |
No |
entrypoint |
string |
Yes |
environment |
map (string) |
Yes |
id |
uuid |
No |
image |
string |
Yes |
name |
string |
No |
namespaceName |
string |
No |
phase |
string |
No |
replicas |
integer |
No |
resources |
ResourceConfigDto |
Yes |
runtime |
string |
No |
scaling |
ScalingConfigDto |
Yes |
secrets |
map (string) |
Yes |
source |
string |
Yes |
sourceCode |
string |
Yes |
trigger |
TriggerDto |
Yes |
FunctionNamespaceDto
| Property | Type | Nullable |
|---|---|---|
boundary |
string |
No |
boundaryId |
uuid |
No |
clusterId |
uuid |
No |
clusterName |
string |
No |
collection |
string |
No |
createdAt |
date-time |
No |
defaultAuth |
AuthConfigDto |
Yes |
defaultResources |
ResourceConfigDto |
Yes |
defaultScaling |
ScalingConfigDto |
Yes |
environment |
map (string) |
Yes |
functionCount |
integer |
No |
functions |
FunctionSummaryDto [] |
No |
host |
string |
No |
id |
uuid |
No |
name |
string |
No |
readyFunctions |
integer |
No |
region |
string |
No |
resourceGroup |
string |
No |
status |
string |
No |
tags |
map (string) |
No |
tls |
TlsDto |
Yes |
FunctionNamespaceNameRequest
| Property | Type | Nullable |
|---|---|---|
name |
string |
No |
FunctionSummaryDto
| Property | Type | Nullable |
|---|---|---|
endpoint |
string |
No |
name |
string |
No |
phase |
string |
No |
replicas |
integer |
No |
runtime |
string |
No |
triggerType |
string |
No |
PagedListResponse<FunctionDto>
| Property | Type | Nullable |
|---|---|---|
items |
FunctionDto [] |
No |
pagination |
PaginationMeta |
No |
PagedListResponse<FunctionNamespaceDto>
| Property | Type | Nullable |
|---|---|---|
items |
FunctionNamespaceDto [] |
No |
pagination |
PaginationMeta |
No |
PaginationMeta
| Property | Type | Nullable |
|---|---|---|
hasNextPage |
boolean |
No |
hasPreviousPage |
boolean |
No |
page |
integer |
No |
pageSize |
integer |
No |
totalItems |
integer |
No |
totalPages |
integer |
No |
ResourceConfigDto
| Property | Type | Nullable |
|---|---|---|
cpu |
string |
No |
memory |
string |
No |
ScaleRequest
| Property | Type | Nullable |
|---|---|---|
problem |
string |
Yes |
replicas |
integer |
Yes |
ScalingConfigDto
| Property | Type | Nullable |
|---|---|---|
cooldownPeriod |
integer |
No |
maxReplicas |
integer |
No |
minReplicas |
integer |
No |
TlsDto
| Property | Type | Nullable |
|---|---|---|
enabled |
boolean |
No |
secretName |
string |
Yes |
TriggerDto
| Property | Type | Nullable |
|---|---|---|
connection |
string |
Yes |
httpRoute |
string |
Yes |
methods |
string [] |
Yes |
queueName |
string |
Yes |
schedule |
string |
Yes |
type |
string |
No |
UploadBuildLogsRequest
| Property | Type | Nullable |
|---|---|---|
boundaryId |
string |
No |
functionName |
string |
Yes |
logs |
string |
No |
namespaceName |
string |
No |
resourceGroupName |
string |
No |
timestamp |
date-time |
No |
UploadSourceRequest
| Property | Type | Nullable |
|---|---|---|
code |
string |
No |
entrypoint |
string |
Yes |